import 'dart:typed_data';

import 'package:ml_algo/src/cost_function/cost_function.dart';
import 'package:ml_algo/src/score_to_prob_link_function/link_function.dart';
import 'package:ml_linalg/linalg.dart';

class LogLikelihoodCost implements CostFunction<Float32x4> {
  final VectorizedScoreToProbLinkFunction<Float32x4> linkFunction;

  const LogLikelihoodCost(this.linkFunction);

  @override
  double getCost(double score, double yOrig) {
    throw UnimplementedError();
  }

  @override
  MLVector<Float32x4> getGradient(MLMatrix<Float32x4> x, MLVector<Float32x4> w, MLVector<Float32x4> y) =>
      (x.transpose() * (y - (x * w).vectorizedMap(linkFunction))).toVector();

  @override
  double getSparseSolutionPartial(int wIdx, MLVector<Float32x4> x, MLVector<Float32x4> w, double y) =>
      throw UnimplementedError();
}
